unit ListsClasses;

interface

uses
  Windows,Classes,Controls,ComCtrls,SysUtils;

type
//  -  ,   
//        
//   ,  ,
//   ,  .

  TCollectionClass = class of TCollection; //  

  THCollection=class; //   

  THCollectionItem = class ( TCollectionItem )
  private
    function GetItem(index: integer): THCollectionItem;
    procedure SetItem(index: integer; const Value: THCollectionItem);
    function GetCollection: THCollection;
    procedure SetCollection(const Value: THCOllection);
    procedure SetItems(const Value: THCollection);
  private //  
    FItems : THCollection;
  public
  //     
    constructor Create ( Collection : TCollection );override;
    destructor destroy;override;
  //      
    function Count : integer;
    function Add : THCollectionItem;
    property Items : THCollection read FItems write SetItems;
    property Item[ index : integer ] :
      THCollectionItem read GetItem write SetItem;default;
  //    -       
    property Collection : THCollection read GetCollection write SetCollection;
  //  (  )
    procedure AssignTo ( Dest : TPersistent );override;
    end;

  THCollection = class ( TCollection )
  private
    function GetItem(index: integer): THCollectionItem;
    procedure SetItem(index: integer; const Value: THCollectionItem);
  public
    function Add : THCollectionItem;
    property Items[ index : integer ] :
       THCollectionItem read GetItem write SetItem;default;
    end;

  //    -     
  // 

  TNamedHCollectionItem = class ( THCollectionItem )
  private
    FName: string;
    FObject: TObject;
    procedure SetName(const Value: string);
    procedure SetObject(const Value: TObject);
  protected
    property DisplayName : string read FName write SetName;//   
    property StoredObject : TObject read FObject write SetObject;
  published
    property Name : string read FName write SetName;
    end;

  TNamedHCollection = class ( THCollection )
  private
    function GetItem(index: integer): TNamedHCollectionItem;
    procedure SetItem(index: integer; const Value: TNamedHCollectionItem);
    function GetObject(Index: integer): TObject;
    procedure SetObject(Index: integer; const Value: TObject);
  public
    function  Add : TNamedHCollectionItem;
    function  Find ( Name : string;HDelimeter:char=#0) : TNamedHCollectionItem;
    property  Items[ index : integer ] : TNamedHCollectionItem
         read GetItem write SetItem;default;
    property  Objects[ Index : integer ] : TObject
         read GetObject write SetObject;
  //  
    procedure AssignTo ( Dest : TPersistent );override;
    procedure Assign ( Source : TPersistent );override;
    end;

implementation

{ THCollectionItem }

function THCollectionItem.Add: THCollectionItem;
begin
  result := THCollectionItem(FItems.Add);
end;

procedure THCollectionItem.AssignTo(Dest: TPersistent);
begin
//   Assign / AssignTo     ""
//    .
  If Dest is THCollectionItem then //   
    begin
    with THCollectionItem(Dest) do
      //    TCollection.Assign,  
      //      .
      //    -    , 
      //       TPersistent.Assign,    
      //  Source.AssignTo(Self),     
      Items.Assign( Self.Items );
    //  ! Exit ,     
    //   
    Exit;
    end;
  //       ,   TPersistent.AssignTo
  //     
  inherited;
end;

function THCollectionItem.Count: integer;
begin
  result := FItems.Count;
end;

constructor THCollectionItem.Create(Collection: TCollection);
var
  C : TCollectionClass;
begin
  inherited;
  //     ,       - ,
  //    ,    .
  //   ,    ,  
  //     RTM,     Initialization
  //     
  C := TCollectionClass(Collection.ClassType);
  FItems := THCollection(C.Create(Collection.ItemClass));
end;

destructor THCollectionItem.destroy;
begin 
  FItems.Free; //   
  inherited;
end;

function THCollectionItem.GetCollection: THCOllection;
begin
  result := THCollection(inherited Collection);
end;

function THCollectionItem.GetItem(index: integer): THCollectionItem;
begin
  result := THCollectionItem(FItems.Items[index]);
end;

procedure THCollectionItem.SetCollection(const Value: THCOllection);
begin
  inherited Collection := Value;
end;

procedure THCollectionItem.SetItem(index: integer;
  const Value: THCollectionItem);
begin
  FItems.Items[index] := Value;
end;

procedure THCollectionItem.SetItems(const Value: THCollection);
begin
  FItems.Assign( Value );
end;

{ THCollection }

function THCollection.Add: THCollectionItem;
begin
  result := THCollectionItem( inherited Add );
end;

function THCollection.GetItem(index: integer): THCollectionItem;
begin
  result := THCollectionItem( inherited Items[index]);
end;

procedure THCollection.SetItem(index: integer;
  const Value: THCollectionItem);
begin
  inherited Items[index] := Value;
end;

{ TNamedHCollectionItem }

procedure TNamedHCollectionItem.SetName(const Value: string);
begin
  FName := Value;
  Changed(false);//     
end;

procedure TNamedHCollectionItem.SetObject(const Value: TObject);
begin
  FObject := Value;
  Changed(true);
end;

{ TNamedHCollection }

function TNamedHCollection.Add: TNamedHCollectionItem;
begin
  result := TNamedHCollectionItem(inherited Add );
end;

//        
// . ""     Assign  AssignTo.
//        , 
//      .  
//        
//     

procedure TNamedHCollection.Assign(Source: TPersistent);
var
  i : integer;
  FItem : TNamedHCollectionItem;
  TN,NN : TTreeNode;
begin
  If Source is TStrings then
    // TStrings  ,   ,      
    begin
    with TStrings(Source) do
      For i:= 0 to Count-1 do //  
        begin
        FItem := Self.Add;
        FItem.Name := Strings[i];
        end;
    exit;
    end;
  If (Source is TListItems) then
    begin
    with TListItems(Source) do //    TListItems
      For i:= 0 to Count-1 do
        begin
        FItem := Self.Add;
        FItem.Name := Item[i].Caption;
        //       TStrings !
        FItem.Items.Assign( Item[i].SubItems );
        end;
      exit;
    end;
  If Source is TTreeNodes then
    begin
    Assign(TTreeNodes(Source).GetFirstNode);
    exit;
    end;
  If Source is TTreeNode then
    begin
    TN := TTreeNode(Source);
    while TN<>nil do
      begin
      FItem := Self.Add;
      FItem.Name := TN.Text;
      NN := TN.GetFirstChild;
      If Assigned ( NN ) then
        FItem.Items.Assign( NN );
      TN := TN.getNextSibling;
      end;
    exit;
    end;
  inherited;
end;

procedure TNamedHCollection.AssignTo(Dest: TPersistent);
var
  i,c : integer;
  LI : TListItem;
  TN : TTreeNode;
begin
  If Dest is TStrings then
    with TStrings(Dest) do
      begin
      Clear; //   
      For i:= 0 to Self.Count-1 do
        begin
        c := Add(Items[i].Name);
        //   -       ,
        //        ,    
        If Dest is TStringList then
          TStringList(Dest).Objects[c] := Self.Objects[i];
        end;
      exit;
      end;
  If Dest is TListItems then
    with TListItems(Dest) do
      begin
      BeginUpdate;
      Clear;
      For i:= 0 to Self.Count-1 do
        begin
        LI := Add;
        LI.Caption := Items[i].Name;
        LI.SubItems.Assign(Items[i].Items);
        end;
      EndUpdate;
      exit;
      end;
  //    .
  If Dest Is TTreeNodes then
    with TTreeNodes(Dest) do
      begin
      BeginUpdate;
      Clear;
      For i:= 0 to Self.Count-1 do
        begin
        TN := AddChild(nil,Items[i].Name);
        TN.Assign(Items[i].Items);
        end;
      EndUpdate;
      exit;
      end;
  If Dest Is TTreeNode then
    with TTreeNode(Dest) do
      begin
      For i:= 0 to Self.Count-1 do
        begin
        TN := Owner.AddChild(TTreeNode(Dest),Items[i].Name);
        TN.Assign(Items[i].Items);
        end;
      exit;
      end;
  inherited;
end;

function TNamedHCollection.Find(Name: string;
  HDelimeter: char): TNamedHCollectionItem;
var
  s : string;
  i : integer;
begin
  Name := ANSIUpperCase(Name);
  If Pos (HDelimeter,Name)>0 then
    Begin
    S := Copy(S,1,Pos (HDelimeter,Name)-1);
    System.Delete(Name,1,Pos (HDelimeter,Name));
    end;
  For i := 0 to Count-1 do
    begin
    result := Items[i];
    If ANSIUpperCase(Result.Name)=Name then
      begin
      If S <> '' then
        Result:=TNamedHCollection(Items[i].Collection).Find(Name,HDelimeter);
      exit;
      end;
    end;
  result := nil;
end;

function TNamedHCollection.GetItem(index: integer): TNamedHCollectionItem;
begin
  result := TNamedHCollectionItem(inherited Items[index]);
end;

function TNamedHCollection.GetObject(Index: integer): TObject;
begin
  result := Items[index].StoredObject;
end;

procedure TNamedHCollection.SetItem(index: integer;
  const Value: TNamedHCollectionItem);
begin
  inherited Items[Index] := Value;
end;

procedure TNamedHCollection.SetObject(Index: integer;
  const Value: TObject);
begin
  Items[Index].StoredObject := Value;
end;

initialization
  //      ,  
  //     RTM.
  RegisterClasses( [THCollection,THCollectionItem,TNamedHCollection,
    TNamedHCollectionItem]);
end.
